首页 > 代码库 > LeetCode——TwoSum
LeetCode——TwoSum
题目:
Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based. You may assume that each input would have exactly one solution. Input: numbers={2, 7, 11, 15}, target=9 Output: index1=1, index2=2我的解法:
public class Solution { public int[] twoSum(int[] numbers, int target) { int [] re=new int[2]; int len=numbers.length; for(int i=0;i<len;i++){ for(int j=i+1;j<len;j++){ if(numbers[i]+numbers[j]==target){ re[0]=i+1; re[1]=j+1; } } } return re; } }系统给出结果:
Time Limit Exceeded
显然系统无法忍受我时间复杂度为O(n^2)的时间复杂度。在讨论版看到一个复杂度为O(n)的算法:
import java.util.Hashtable; public class Solution { public int[] twoSum(int[] numbers, int target) { int [] re=new int[2]; Hashtable<Integer,Integer> hashtable=new Hashtable<Integer,Integer>(); int len=numbers.length; for(int i=0;i<len;i++){ Integer n=hashtable.get(numbers[i]); if(n==null) hashtable.put(numbers[i],i); n=hashtable.get(target-numbers[i]); if(n!=null&&n<i){ re[0]=n+1; re[1]=i+1; return re; } } return re; } }
LeetCode——TwoSum
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。